## START: Set by rpmautospec
## (rpmautospec version 0.2.5)
%define autorelease(e:s:pb:) %{?-p:0.}%{lua:
    release_number = 1;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{?dist}
## END: Set by rpmautospec

%bcond_without check

%if 0%{?rhel}
%global bundled_rust_deps 1
%else
%global bundled_rust_deps 0
%endif

%global tarball_version %%(echo %{version} | tr '~' '.')

Name:           glycin-loaders
Version:        0.1.2
Release:        %autorelease
Summary:        Sandboxed image rendering

# (Apache-2.0 OR MIT) AND BSD-3-Clause
# (MIT OR Apache-2.0) AND Unicode-DFS-2016
# 0BSD OR MIT OR Apache-2.0
# Apache-2.0
# Apache-2.0 OR MIT
# Apache-2.0 WITH LLVM-exception OR Apache-2.0 OR MIT
# BSD-2-Clause
# LGPL-2.1-or-later
# MIT
# MIT OR Apache-2.0
# MIT OR Apache-2.0 OR Zlib
# MIT OR Zlib OR Apache-2.0
# MPL-2.0
# MPL-2.0 OR LGPL-2.1-or-later
# Unlicense OR MIT
# Zlib OR Apache-2.0 OR MIT
License:        (Apache-2.0 OR MIT) AND BSD-3-Clause AND (MIT OR Apache-2.0) AND Unicode-DFS-2016 AND (0BSD OR MIT OR Apache-2.0) AND Apache-2.0 AND (Apache-2.0 OR MIT) AND (Apache-2.0 WITH LLVM-exception OR Apache-2.0 OR MIT) AND BSD-2-Clause AND LGPL-2.1-or-later AND MIT AND (MIT OR Apache-2.0) AND (MIT OR Apache-2.0 OR Zlib) AND (MIT OR Zlib OR Apache-2.0) AND MPL-2.0 AND (MPL-2.0 OR LGPL-2.1-or-later) AND (Unlicense OR MIT) AND (Zlib OR Apache-2.0 OR MIT)
# LICENSE.dependencies contains a full license breakdown
URL:            https://gitlab.gnome.org/sophie-h/glycin
Source0:        https://download.gnome.org/sources/glycin-loaders/0.1/glycin-loaders-%{tarball_version}.tar.xz
# Fedora-packaged rust-image doesn't have openexr support
Patch:          0001-Drop-OpenEXR-decoders-since-they-are-not-enabled-in-.patch
%if 0%{?fedora}
# Bump libheif-rs dep to the version that's in Fedora
Patch:          0004-Bump-libheif-rs-dep-0.21.0.patch
%endif

# https://fedoraproject.org/wiki/Changes/EncourageI686LeafRemoval
ExcludeArch:    %{ix86}

%if 0%{?rhel}
BuildRequires:  rust-toolset
%else
BuildRequires:  cargo-rpm-macros
%endif
BuildRequires:  git-core
BuildRequires:  meson
BuildRequires:  pkgconfig(gtk4)

%description
Sandboxed and extendable image decoding.


%prep
%autosetup -p1 -n glycin-loaders-%{tarball_version}

%if ! 0%{?bundled_rust_deps}
rm -rf vendor
%cargo_prep
%endif


%if ! 0%{?bundled_rust_deps}
%generate_buildrequires
%cargo_generate_buildrequires
%endif


%build
%meson \
  -Dloaders=%{!?rhel:glycin-heif,}glycin-image-rs,glycin-jxl,glycin-svg \
  -Dtest_skip_install=true \
  %{nil}

%meson_build

%if !0%{?rhel}
%cargo_license_summary
%{cargo_license} > LICENSE.dependencies
%endif


%install
%meson_install


%if %{with check}
%check
# Something is wrong with the test setup and tests fail with
# "No such file or directory"
%meson_test || :
%endif


%files
%license LICENSE LICENSE-LGPL-2.1 LICENSE-MPL-2.0
%if !0%{?rhel}
%license LICENSE.dependencies
%endif
%doc NEWS README.md
%{_libexecdir}/glycin-loaders/
%{_datadir}/glycin-loaders/


%changelog
* Tue Nov 14 2023 Kalev Lember <klember@redhat.com> 0.1.2-1
- Update to 0.1.2

* Tue Nov 14 2023 Kalev Lember <klember@redhat.com> 0.1.1-7
- Update license tag for dependencies

* Tue Nov 14 2023 Kalev Lember <klember@redhat.com> 0.1.1-6
- Enable glycin-jxl loader

* Mon Nov 13 2023 Yaakov Selkowitz <yselkowi@redhat.com> 0.1.1-5
- Fix RHEL build

* Thu Nov 09 2023 Kalev Lember <klember@redhat.com> 0.1.1-4
- Enable glycin-heif loader

* Sun Oct 01 2023 Kalev Lember <klember@redhat.com> 0.1.1-3
- Drop downstream patch to use librsvg pre-release version

* Thu Sep 21 2023 Kalev Lember <klember@redhat.com> 0.1.1-2
- Enable heif support now that rust-libheif-rs is packaged

* Tue Sep 19 2023 Fabio Valentini <decathorpe@gmail.com> 0.1.1-1
- Update to version 0.1.1

* Thu Sep 07 2023 Kalev Lember <klember@redhat.com> 0.1~rc-4
- ExcludeArch i686 for
  https://fedoraproject.org/wiki/Changes/EncourageI686LeafRemoval

* Thu Sep 07 2023 Kalev Lember <klember@redhat.com> 0.1~rc-3
- Skip install during self tests

* Thu Sep 07 2023 Kalev Lember <klember@redhat.com> 0.1~rc-2
- Use bundled rust deps on RHEL

* Wed Sep 06 2023 Kalev Lember <klember@redhat.com> 0.1~rc-1
- Update to 0.1.rc

* Wed Aug 23 2023 Kalev Lember <klember@redhat.com> 0.1~beta.4-2
- Enable qoi support now that it's available in rust-image

* Wed Aug 23 2023 Kalev Lember <klember@redhat.com> 0.1~beta.4-1
- Update to 0.1.0-beta.4

* Tue Aug 22 2023 Kalev Lember <klember@redhat.com> 0.1~beta.3-3
- Re-enable tests, but ignore the results for now

* Tue Aug 22 2023 Kalev Lember <klember@redhat.com> 0.1~beta.3-2
- Temorarily disable tests

* Tue Aug 22 2023 Kalev Lember <klember@redhat.com> 0.1~beta.3-1
- Update to 0.1.beta.3

* Mon Aug 21 2023 Kalev Lember <klember@redhat.com> 0.1~beta.2-2
- Update the license tag to reflect the licenses of all rust dependencies

* Mon Aug 21 2023 Kalev Lember <klember@redhat.com> 0.1~beta.2-1
- Initial Fedora packaging (rhbz#2233278)
